# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files asymptote.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys
import platform

if platform.system()=="Linux" :
    sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *


sys.path.append("../Divers/")
from pro_divers import *




class Asymptote:

    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self,parent):
        self.parent=parent
        interface = gtk.Builder()
        interface.add_from_file('asymptote.glade')
        self.windowAS=interface.get_object("windowAS")
        self.checkbuttonASH1 = interface.get_object("checkbuttonASH1")
        self.checkbuttonASH2 = interface.get_object("checkbuttonASH2")
        self.checkbuttonASV1 = interface.get_object("checkbuttonASV1")
        self.checkbuttonASV2 = interface.get_object("checkbuttonASV2")
        self.checkbuttonASO1 = interface.get_object("checkbuttonASO1")
        self.checkbuttonASO2 = interface.get_object("checkbuttonASO2")
        
        self.checkbuttonMIASH1 = interface.get_object("checkbuttonMIASH1")
        self.checkbuttonMIASH2 = interface.get_object("checkbuttonMIASH2")
        self.checkbuttonMIASV1 = interface.get_object("checkbuttonMIASV1")
        self.checkbuttonMIASV2 = interface.get_object("checkbuttonMIASV2")
        self.checkbuttonMIASO1 = interface.get_object("checkbuttonMIASO1")
        self.checkbuttonMIASO2 = interface.get_object("checkbuttonMIASO2")
        
        self.checkbuttonPIASH1 = interface.get_object("checkbuttonPIASH1")
        self.checkbuttonPIASH2 = interface.get_object("checkbuttonPIASH2")
        self.checkbuttonPIASV1 = interface.get_object("checkbuttonPIASV1")
        self.checkbuttonPIASV2 = interface.get_object("checkbuttonPIASV2")
        self.checkbuttonPIASO1 = interface.get_object("checkbuttonPIASO1")
        self.checkbuttonPIASO2 = interface.get_object("checkbuttonPIASO2")
        
        
        self.entryASH1 = interface.get_object("entryASH1")
        self.entryASH2 = interface.get_object("entryASH2")
        self.entryASV1 = interface.get_object("entryASV1")
        self.entryASV2 = interface.get_object("entryASV2")
        self.entryASO1 = interface.get_object("entryASO1")
        self.entryASO2 = interface.get_object("entryASO2")

        
        self.comboboxCouleurASH1 = interface.get_object("comboboxCouleurASH1")
        self.comboboxCouleurASH2 = interface.get_object("comboboxCouleurASH2")
        self.comboboxCouleurASV1 = interface.get_object("comboboxCouleurASV1")
        self.comboboxCouleurASV2 = interface.get_object("comboboxCouleurASV2")
        self.comboboxCouleurASO1 = interface.get_object("comboboxCouleurASO1")
        self.comboboxCouleurASO2 = interface.get_object("comboboxCouleurASO2")



        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        interface.connect_signals(self)

        #Couleur par défaut : noir
        self.comboboxCouleurASH1.set_active(2)
        self.comboboxCouleurASH2.set_active(2)
        self.comboboxCouleurASV1.set_active(2)
        self.comboboxCouleurASV2.set_active(2)
        self.comboboxCouleurASO1.set_active(2)
        self.comboboxCouleurASO2.set_active(2)

        
        #désactivation
        self.comboboxCouleurASH1.set_sensitive(False)
        self.entryASH1.set_sensitive(False)
        self.checkbuttonMIASH1.set_sensitive(False)
        self.checkbuttonPIASH1.set_sensitive(False)
        
        self.comboboxCouleurASH2.set_sensitive(False)
        self.entryASH2.set_sensitive(False)
        self.checkbuttonMIASH2.set_sensitive(False)
        self.checkbuttonPIASH2.set_sensitive(False)
        
        self.comboboxCouleurASV1.set_sensitive(False)
        self.entryASV1.set_sensitive(False)
        self.checkbuttonMIASV1.set_sensitive(False)
        self.checkbuttonPIASV1.set_sensitive(False)
        
        self.comboboxCouleurASV2.set_sensitive(False)
        self.entryASV2.set_sensitive(False)
        self.checkbuttonMIASV2.set_sensitive(False)
        self.checkbuttonPIASV2.set_sensitive(False)
        
        self.comboboxCouleurASO1.set_sensitive(False)
        self.entryASO1.set_sensitive(False)
        self.checkbuttonMIASO1.set_sensitive(False)
        self.checkbuttonPIASO1.set_sensitive(False)
        
        self.comboboxCouleurASO2.set_sensitive(False)
        self.entryASO2.set_sensitive(False)
        self.checkbuttonMIASO2.set_sensitive(False)
        self.checkbuttonPIASO2.set_sensitive(False)
        
        

    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowAS_destroy(self, widget):
        gtk.main_quit()

        
    #-------------------------------------------------------------
    # Met à jour le code à insérer
    #-------------------------------------------------------------  
    def maj_codeasymptote(self):
        Texte_Code=""
        #---------------------------------------
        if self.checkbuttonASH1.get_active()==True:
                Val=self.entryASH1.get_text()
                Couleur=self.comboboxCouleurASH1.get_active_text()
                Couleur=Nom_Couleur(Couleur)
                if self.checkbuttonMIASH1.get_active()==True and self.checkbuttonPIASH1.get_active()==True:
                    Texte_Code=Texte_Code+"[\"asymp-hori\","+Val+",[-infinity,+infinity],\""+Couleur+"\"],\n"
                if self.checkbuttonMIASH1.get_active()==True and self.checkbuttonPIASH1.get_active()==False:
                    Texte_Code=Texte_Code+"[\"asymp-hori\","+Val+",[-infinity],\""+Couleur+"\"],\n"
                if self.checkbuttonMIASH1.get_active()==False and self.checkbuttonPIASH1.get_active()==True:
                    Texte_Code=Texte_Code+"[\"asymp-hori\","+Val+",[+infinity],\""+Couleur+"\"],\n"
                    
        #---------------------------------------
        if self.checkbuttonASH2.get_active()==True:
                Val=self.entryASH2.get_text()
                Couleur=self.comboboxCouleurASH2.get_active_text()
                Couleur=Nom_Couleur(Couleur)
                if self.checkbuttonMIASH2.get_active()==True and self.checkbuttonPIASH2.get_active()==True:
                    Texte_Code=Texte_Code+"[\"asymp-hori\","+Val+",[-infinity,+infinity],\""+Couleur+"\"],\n"
                if self.checkbuttonMIASH2.get_active()==True and self.checkbuttonPIASH2.get_active()==False:
                    Texte_Code=Texte_Code+"[\"asymp-hori\","+Val+",[-infinity],\""+Couleur+"\"],\n"
                if self.checkbuttonMIASH2.get_active()==False and self.checkbuttonPIASH2.get_active()==True:
                    Texte_Code=Texte_Code+"[\"asymp-hori\","+Val+",[+infinity],\""+Couleur+"\"],\n"
                    
        #---------------------------------------
        if self.checkbuttonASV1.get_active()==True:
                Val=self.entryASV1.get_text()
                Couleur=self.comboboxCouleurASV1.get_active_text()
                Couleur=Nom_Couleur(Couleur)
                if self.checkbuttonMIASV1.get_active()==True and self.checkbuttonPIASV1.get_active()==True:
                    Texte_Code=Texte_Code+"[\"asymp-verti\","+Val+",[-infinity,+infinity],\""+Couleur+"\"],\n"
                if self.checkbuttonMIASV1.get_active()==True and self.checkbuttonPIASV1.get_active()==False:
                    Texte_Code=Texte_Code+"[\"asymp-verti\","+Val+",[-infinity],\""+Couleur+"\"],\n"
                if self.checkbuttonMIASV1.get_active()==False and self.checkbuttonPIASV1.get_active()==True:
                    Texte_Code=Texte_Code+"[\"asymp-verti\","+Val+",[+infinity],\""+Couleur+"\"],\n"
                    
        #---------------------------------------
        if self.checkbuttonASV2.get_active()==True:
                Val=self.entryASV2.get_text()
                Couleur=self.comboboxCouleurASV2.get_active_text()
                Couleur=Nom_Couleur(Couleur)
                if self.checkbuttonMIASV2.get_active()==True and self.checkbuttonPIASV2.get_active()==True:
                    Texte_Code=Texte_Code+"[\"asymp-verti\","+Val+",[-infinity,+infinity],\""+Couleur+"\"],\n"
                if self.checkbuttonMIASV2.get_active()==True and self.checkbuttonPIASV2.get_active()==False:
                    Texte_Code=Texte_Code+"[\"asymp-verti\","+Val+",[-infinity],\""+Couleur+"\"],\n"
                if self.checkbuttonMIASV2.get_active()==False and self.checkbuttonPIASV2.get_active()==True:
                    Texte_Code=Texte_Code+"[\"asymp-verti\","+Val+",[+infinity],\""+Couleur+"\"],\n"        
                    
        #---------------------------------------
        if self.checkbuttonASO1.get_active()==True:
                Val=self.entryASO1.get_text()
                Couleur=self.comboboxCouleurASO1.get_active_text()
                Couleur=Nom_Couleur(Couleur)
                if self.checkbuttonMIASO1.get_active()==True and self.checkbuttonPIASO1.get_active()==True:
                    Texte_Code=Texte_Code+"[\"asymp-obli\","+Val+",[-infinity,+infinity],\""+Couleur+"\"],\n"
                if self.checkbuttonMIASO1.get_active()==True and self.checkbuttonPIASO1.get_active()==False:
                    Texte_Code=Texte_Code+"[\"asymp-obli\","+Val+",[-infinity],\""+Couleur+"\"],\n"
                if self.checkbuttonMIASO1.get_active()==False and self.checkbuttonPIASO1.get_active()==True:
                    Texte_Code=Texte_Code+"[\"asymp-obli\","+Val+",[+infinity],\""+Couleur+"\"],\n"
                    
        #---------------------------------------
        if self.checkbuttonASO2.get_active()==True:
                Val=self.entryASO2.get_text()
                Couleur=self.comboboxCouleurASO2.get_active_text()
                Couleur=Nom_Couleur(Couleur)
                if self.checkbuttonMIASO2.get_active()==True and self.checkbuttonPIASO2.get_active()==True:
                    Texte_Code=Texte_Code+"[\"asymp-obli\","+Val+",[-infinity,+infinity],\""+Couleur+"\"],\n"
                if self.checkbuttonMIASO2.get_active()==True and self.checkbuttonPIASO2.get_active()==False:
                    Texte_Code=Texte_Code+"[\"asymp-obli\","+Val+",[-infinity],\""+Couleur+"\"],\n"
                if self.checkbuttonMIASO2.get_active()==False and self.checkbuttonPIASO2.get_active()==True:
                    Texte_Code=Texte_Code+"[\"asymp-obli\","+Val+",[+infinity],\""+Couleur+"\"],\n"             
                        
    
        
        self.Texte_Asymptote=Texte_Code
        if self.parent.initialisation==False:
            self.parent.maj_codeprofessor()

    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition des textes
    #-------------------------------------------------------------      
    
    #-----------------------------------------ASH1
    def on_checkbuttonASH1_clicked(self,widget):
        self.maj_codeasymptote()
        if self.checkbuttonASH1.get_active()==True:
            self.entryASH1.set_sensitive(True)
            self.comboboxCouleurASH1.set_sensitive(True)
            self.checkbuttonMIASH1.set_sensitive(True)
            self.checkbuttonPIASH1.set_sensitive(True)
        else:
            self.entryASH1.set_sensitive(False)
            self.comboboxCouleurASH1.set_sensitive(False)
            self.checkbuttonMIASH1.set_sensitive(False)
            self.checkbuttonPIASH1.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryASH1_changed(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False

        
    def on_comboboxCouleurASH1_changed(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False
        
    def on_checkbuttonMIASH1_clicked(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False 
        
    def on_checkbuttonPIASH1_clicked(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False 
        
    #-----------------------------------------ASH2
    def on_checkbuttonASH2_clicked(self,widget):
        self.maj_codeasymptote()
        if self.checkbuttonASH2.get_active()==True:
            self.entryASH2.set_sensitive(True)
            self.comboboxCouleurASH2.set_sensitive(True)
            self.checkbuttonMIASH2.set_sensitive(True)
            self.checkbuttonPIASH2.set_sensitive(True)
        else:
            self.entryASH2.set_sensitive(False)
            self.comboboxCouleurASH2.set_sensitive(False)
            self.checkbuttonMIASH2.set_sensitive(False)
            self.checkbuttonPIASH2.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryASH2_changed(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False

        
    def on_comboboxCouleurASH2_changed(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False
        
    def on_checkbuttonMIASH2_clicked(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False 
        
    def on_checkbuttonPIASH2_clicked(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False 
    #-----------------------------------------ASV1
    def on_checkbuttonASV1_clicked(self,widget):
        self.maj_codeasymptote()
        if self.checkbuttonASV1.get_active()==True:
            self.entryASV1.set_sensitive(True)
            self.comboboxCouleurASV1.set_sensitive(True)
            self.checkbuttonMIASV1.set_sensitive(True)
            self.checkbuttonPIASV1.set_sensitive(True)
        else:
            self.entryASV1.set_sensitive(False)
            self.comboboxCouleurASV1.set_sensitive(False)
            self.checkbuttonMIASV1.set_sensitive(False)
            self.checkbuttonPIASV1.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryASV1_changed(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False

        
    def on_comboboxCouleurASV1_changed(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False
        
    def on_checkbuttonMIASV1_clicked(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False 
        
    def on_checkbuttonPIASV1_clicked(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False 
        
    #-----------------------------------------ASV2
    def on_checkbuttonASV2_clicked(self,widget):
        self.maj_codeasymptote()
        if self.checkbuttonASV2.get_active()==True:
            self.entryASV2.set_sensitive(True)
            self.comboboxCouleurASV2.set_sensitive(True)
            self.checkbuttonMIASV2.set_sensitive(True)
            self.checkbuttonPIASV2.set_sensitive(True)
        else:
            self.entryASV2.set_sensitive(False)
            self.comboboxCouleurASV2.set_sensitive(False)
            self.checkbuttonMIASV2.set_sensitive(False)
            self.checkbuttonPIASV2.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryASV2_changed(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False

        
    def on_comboboxCouleurASV2_changed(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False
        
    def on_checkbuttonMIASV2_clicked(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False 
        
    def on_checkbuttonPIASV2_clicked(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False 
                
    #-----------------------------------------ASO1
    def on_checkbuttonASO1_clicked(self,widget):
        self.maj_codeasymptote()
        if self.checkbuttonASO1.get_active()==True:
            self.entryASO1.set_sensitive(True)
            self.comboboxCouleurASO1.set_sensitive(True)
            self.checkbuttonMIASO1.set_sensitive(True)
            self.checkbuttonPIASO1.set_sensitive(True)
        else:
            self.entryASO1.set_sensitive(False)
            self.comboboxCouleurASO1.set_sensitive(False)
            self.checkbuttonMIASO1.set_sensitive(False)
            self.checkbuttonPIASO1.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryASO1_changed(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False

        
    def on_comboboxCouleurASO1_changed(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False
        
    def on_checkbuttonMIASO1_clicked(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False 
        
    def on_checkbuttonPIASO1_clicked(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False 
        
    #-----------------------------------------ASO2
    def on_checkbuttonASO2_clicked(self,widget):
        self.maj_codeasymptote()
        if self.checkbuttonASO2.get_active()==True:
            self.entryASO2.set_sensitive(True)
            self.comboboxCouleurASO2.set_sensitive(True)
            self.checkbuttonMIASO2.set_sensitive(True)
            self.checkbuttonPIASO2.set_sensitive(True)
        else:
            self.entryASO2.set_sensitive(False)
            self.comboboxCouleurASO2.set_sensitive(False)
            self.checkbuttonMIASO2.set_sensitive(False)
            self.checkbuttonPIASO2.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_entryASO2_changed(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False

        
    def on_comboboxCouleurASO2_changed(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False
        
    def on_checkbuttonMIASO2_clicked(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False 
        
    def on_checkbuttonPIASO2_clicked(self,widget):
        self.maj_codeasymptote()
        self.Etat_Compilation=False 
                
        

            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    Asymptote()
    gtk.main()

